_TITLE "LED Date and Time"

DIM Text AS STRING
DIM Temp AS STRING

DIM Title AS STRING
DIM Touch AS STRING

Title = SPACE$(9) + "LED Date & Time Display - Created by: Code Hunter" + SPACE$(9)

DIM SHARED DotMatrix(16) AS STRING
DIM SHARED Font(256) AS STRING

TimeFlag = 24

CLS: SCREEN 12

CALL ShowDate

Tag = 1
WHILE NOT Quit
    Touch = INKEY$
    IF Touch = CHR$(27) THEN SYSTEM

    IF UCASE$(Touch) = "F" THEN
        IF TimeFlag = 12 THEN TimeFlag = 24 ELSE TimeFlag = 12
    END IF

    Display 104, 0, MID$(Title, Tag, 9), 13
    Tag = Tag + 1: IF Tag = LEN(Title) - 8 THEN Tag = 1

    Text = NewTime(TimeFlag)
    Display 320 - 24 * LEN(Text), 96, Text, 9

    Seconds = VAL(RIGHT$(TIME$, 2))

    SELECT CASE Seconds \ 15 MOD 4
        CASE 0: x = 3: y = 0: Display 3, 384, "  ", 0
        CASE 1: x = 540: y = 0: Display 3, 0, "  ", 0
        CASE 2: x = 540: y = 384: Display 540, 0, "  ", 0
        CASE 3: x = 3: y = 384: Display 540, 384, "  ", 0
    END SELECT

    Display x, y, RIGHT$(TIME$, 2), 3

    IF TIME$ = "00:00:00" THEN CALL ShowDate

    _LIMIT 5
WEND
END

FUNCTION DayName$
    SELECT CASE DayOfWeek(DATE$)
        CASE 0: DayName = "Sunday"
        CASE 1: DayName = "Monday"
        CASE 2: DayName = "Tuesday"
        CASE 3: DayName = "Wednesday"
        CASE 4: DayName = "Thursday"
        CASE 5: DayName = "Friday"
        CASE 6: DayName = "Saturday"
    END SELECT
END FUNCTION

FUNCTION MonthName$
    SELECT CASE VAL(LEFT$(DATE$, 2))
        CASE 1: MonthName = "January"
        CASE 2: MonthName = "February"
        CASE 3: MonthName = "March"
        CASE 4: MonthName = "April"
        CASE 5: MonthName = "May"
        CASE 6: MonthName = "June"
        CASE 7: MonthName = "July"
        CASE 8: MonthName = "August"
        CASE 9: MonthName = "September"
        CASE 10: MonthName = "October"
        CASE 11: MonthName = "November"
        CASE 12: MonthName = "December"
    END SELECT
END FUNCTION

FUNCTION DayNumber&& (DateStr AS STRING)
    M = VAL(LEFT$(DateStr, 2))
    D = VAL(MID$(DateStr, 4, 2))
    Y = VAL(RIGHT$(DateStr, 4))

    IF M > 2 THEN M = M + 1 ELSE Y = Y - 1: M = M + 13
    DayNumber = Y * 365 + Y \ 4 - Y \ 100 + Y \ 400 + M * 306001 \ 10000 + D
END FUNCTION

FUNCTION DayOfWeek (DateStr AS STRING)
    M = VAL(LEFT$(DateStr, 2))
    D = VAL(MID$(DateStr, 4, 2))
    Y = VAL(RIGHT$(DateStr, 4))

    IF M < 3 THEN M = M + 12: Y = Y - 1
    DayOfWeek = ((13 * M + 3) \ 5 + D + Y + Y \ 4 - Y \ 100 + Y \ 400 + 1) MOD 7
END FUNCTION

FUNCTION DaySuffix$ (Day)
    DIM Temp AS STRING

    Temp = "th"
    IF Day MOD 10 = 1 THEN Temp = "st"
    IF Day MOD 10 = 2 THEN Temp = "nd"
    IF Day MOD 10 = 3 THEN Temp = "rd"

    IF Day > 10 AND Day < 14 THEN Temp = "th"

    DaySuffix = Temp
END FUNCTION

FUNCTION NewTime$ (Flag)
    DIM Post AS STRING

    IF Flag <> 12 AND Flag <> 24 THEN EXIT SUB

    IF Flag = 12 THEN
        Hour24 = VAL(LEFT$(TIME$, 2))
        Post = " AM": IF Hour24 > 11 THEN Post = " PM"
        IF Hour24 > 11 THEN Hour12 = Hour24 - 12 ELSE Hour12 = Hour24

        IF Hour12 = 0 THEN Hour12 = 12

        NewTime = RIGHT$("0" + LTRIM$(STR$(Hour12)), 2) + MID$(TIME$, 3, 3) + Post
    ELSE
        NewTime = "  " + LEFT$(TIME$, 2) + MID$(TIME$, 4, 2) + "  "
    END IF
END FUNCTION

SUB CircleFill (CX, CY, R, C)
    Radius = ABS(R): RadiusError = -Radius

    X = Radius: Y = 0
    IF Radius = 0 THEN
        PSET (CX, CY), C
    ELSE
        LINE (CX - X, CY)-(CX + X, CY), C, BF

        WHILE X > Y
            RadiusError = RadiusError + Y * 2 + 1
            IF RadiusError >= 0 THEN
                IF X <> Y + 1 THEN
                    LINE (CX - Y, CY - X)-(CX + Y, CY - X), C, BF
                    LINE (CX - Y, CY + X)-(CX + Y, CY + X), C, BF
                END IF

                X = X - 1: RadiusError = RadiusError - X * 2
            END IF

            Y = Y + 1
            LINE (CX - X, CY - Y)-(CX + X, CY - Y), C, BF
            LINE (CX - X, CY + Y)-(CX + X, CY + Y), C, BF
        WEND
    END IF
END SUB

SUB Display (TX, TY, Text AS STRING, TC)
    DIM Temp AS STRING

    FOR Wipe = 1 TO 16: DotMatrix(Wipe) = "": NEXT

    FOR Char = 1 TO LEN(Text)
        A = ASC(MID$(Text, Char, 1)) + 1

        FOR V = 0 TO 15
            DotMatrix(V + 1) = DotMatrix(V + 1) + MID$(Font(A), 8 * V + 1, 8)
        NEXT
    NEXT

    FOR V = 0 TO 15
        Temp = DotMatrix(V + 1)

        FOR H = 0 TO LEN(DotMatrix(V + 1))
            CircleFill H * 6 + TX, V * 6 + TY, 2, TC * VAL(MID$(Temp, H + 1, 1))
        NEXT
    NEXT
END SUB

SUB ShowDate
    DIM Text AS STRING

    LoadFont 20: Colour = 6

    Text = DayName
    Display 320 - 24 * LEN(Text), 192, Text, 6

    Day = VAL(MID$(DATE$, 4, 2))
    Text = MonthName + STR$(Day) + DaySuffix(Day)
    Display 320 - 24 * LEN(Text), 288, Text, 6

    LoadFont 13: Colour = 9

    Text = RIGHT$(DATE$, 4)
    Display 320 - 24 * LEN(Text), 384, Text, 6
END SUB

SUB LoadFont (Value)
    IF Value = 13 OR Value = 20 THEN
        IF Value = 13 THEN RESTORE Font13
        IF Value = 20 THEN RESTORE Font20

        FOR Char = 1 TO 256: READ Font(Char): NEXT
        EXIT SUB
    END IF

    Font13:
    DATA "00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000111111010000001101001011000000110000001101111011001100110000001011111100000000000000000000000000000000000000000"
    DATA "00000000000000000111111011111111110110111111111111111111110000111110011111111111011111100000000000000000000000000000000000000000"
    DATA "00000000000000000000000000110110011111110111111101111111011111110011111000011100000010000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000001000000111000011111001111111001111100001110000001000000000000000000000000000000000000000000000000000"
    DATA "00000000000110000011110000111100111001111110011111100111001111000001100000011000001111000000000000000000000000000000000000000000"
    DATA "00000000000000000001100000111100011111101111111111111111011111100001100000011000001111000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000001100000111100001111000001100000000000000000000000000000000000000000000000000000000000"
    DATA "11111111111111111111111111111111111111111110011111000011100000011110011111111111111111111111111111111111111111110000000000000000"
    DATA "00000000000000000000000000000000001111000110011001000010010000100110011000111100000000000000000000000000000000000000000000000000"
    DATA "11111111111111111111111111111111110000111001100110111101101111011001100111000011111111111111111111111111111111110000000000000000"
    DATA "00000000000000000000111100000111000011010001100100111100011001100110011001100110001111000000000000000000000000000000000000000000"
    DATA "00000000000000000011110001100110011001100110011000111100000110000111111000011000000110000000000000000000000000000000000000000000"
    DATA "00000000000000000011111100110011001111110011000000110000001100000111000011110000111000000000000000000000000000000000000000000000"
    DATA "00000000000000000111111101100011011111110110001101100011011000110110011111100111111001100110000000000000000000000000000000000000"
    DATA "00000000000000000001100000011000110110110011110011100111001111001101101100011000000110000000000000000000000000000000000000000000"
    DATA "00000000100000001100000011100000111100001111100011111110111110001111000011100000110000001000000000000000000000000000000000000000"
    DATA "00000000000000100000011000001110000111100011111011111110001111100001111000001110000001100000001000000000000000000000000000000000"
    DATA "00000000000000000001100000111100011111100001100000011000000110000111111000111100000110000000000000000000000000000000000000000000"
    DATA "00000000000000000110011001100110011001100110011001100110011001100110011000000000011001100110011000000000000000000000000000000000"
    DATA "00000000000000000111111111011011110110111101101101111011000110110001101100011011000110110001101100000000000000000000000000000000"
    DATA "00000000011111001100011001100000001110000110110011000110110001100110110000111000000011001100011001111100000000000000000000000000"
    DATA "00000000000000000000000000000000000000000000000000000000000000001111111011111110111111101111111000000000000000000000000000000000"
    DATA "00000000000000000001100000111100011111100001100000011000000110000111111000111100000110000111111000000000000000000000000000000000"
    DATA "00000000000000000001100000111100011111100001100000011000000110000001100000011000000110000001100000000000000000000000000000000000"
    DATA "00000000000000000001100000011000000110000001100000011000000110000001100001111110001111000001100000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000001100000001100111111100000110000011000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000011000001100000111111100110000000110000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000000000011000000110000001100000011111110000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000010010001100110111111110110011000100100000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000100000011100000111000011111000111110011111110111111100000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000111111101111111001111100011111000011100000111000000100000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000100000011100000111000001110000001000000010000000000000001000000010000000000000000000000000000000000000000000"
    DATA "00000000011001100110011000100010001000100000000000000000000000000000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000010010000100100011111100010010000100100001001000111111000100100001001000000000000000000000000000000000000000000"
    DATA "00001100000011000011111101000011010000010100000000111110000000010100000101000001001111100000110000001100000000000000000000000000"
    DATA "00000000000000000000000000000000011000010110001100000110000011000001100000110011011000110000000000000000000000000000000000000000"
    DATA "00000000000000000011100001000100010010000011000000100000010100100100110001000110001110010000000000000000000000000000000000000000"
    DATA "00000000011000000110000000100000001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000110000010000001000000010000000100000001000000010000000010000000011000000000000000000000000000000000000000000"
    DATA "00000000000000000001100000000100000000100000001000000010000000100000001000000100000110000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000011001100011110011111111001111000110011000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000001000000010000000100001111111000010000000100000001000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000000000000000000000000000001100000011000000110000011000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000000000000000000011111110000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000000000000000000000000000000000000011000000110000000000000000000000000000000000000000000"
    DATA "00000000000000000000000100000011000001100000110000011000001100000110000011000000100000000000000000000000000000000000000000000000"
    DATA "00000000000000000001110000100010010000010100000101000001010000010100000100100010000111000000000000000000000000000000000000000000"
    DATA "00000000000000000001110000000100000001000000010000000100000001000000010000000100000111110000000000000000000000000000000000000000"
    DATA "00000000000000000011111001000001000000010000001000000100000010000001000000100001011111110000000000000000000000000000000000000000"
    DATA "00000000000000000011111001000001000000010000000100011110000000010000000101000001001111100000000000000000000000000000000000000000"
    DATA "00000000000000000000011000001010000100100010001001000010011111110000001000000010000011110000000000000000000000000000000000000000"
    DATA "00000000000000000111111101000000010000000100000001111110000000010000000101000001001111100000000000000000000000000000000000000000"
    DATA "00000000000000000001111000100000010000000100000001111110010000010100000101000001001111100000000000000000000000000000000000000000"
    DATA "00000000000000000111111101000001000000010000001000000100000010000001000000100000001000000000000000000000000000000000000000000000"
    DATA "00000000000000000011111001000001010000010100000100111110010000010100000101000001001111100000000000000000000000000000000000000000"
    DATA "00000000000000000011111001000001010000010100000100111111000000010000000100000010001111000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000011000000110000000000000000000000110000001100000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000011000000110000000000000000000000000000001100000011000001100000000000000000000000000000000000000000000"
    DATA "00000000000000000000011000001100000110000011000001100000001100000001100000001100000001100000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000111111000000000000000000111111000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000110000000110000000110000000110000000110000011000001100000110000011000000000000000000000000000000000000000000000"
    DATA "00000000000000000011111001000001010000010000011000000100000001000000000000001110000011100000000000000000000000000000000000000000"
    DATA "00000000000000000011111001000001010000010100111101001001010011110100000001000000001111100000000000000000000000000000000000000000"
    DATA "00000000000000000000100000011100001101100010001000100010001111100010001000100010011101110000000000000000000000000000000000000000"
    DATA "00000000000000000111111000100001001000010010000100111110001000010010000100100001011111100000000000000000000000000000000000000000"
    DATA "00000000000000000001111000100011010000010100000001000000010000000100000000100001000111100000000000000000000000000000000000000000"
    DATA "00000000000000000111111000100001001000010010000100100001001000010010000100100001011111100000000000000000000000000000000000000000"
    DATA "00000000000000000111111100100001001000010010010000111100001001000010000100100001011111110000000000000000000000000000000000000000"
    DATA "00000000000000000111111100100001001000010010010000111100001001000010000000100000011110000000000000000000000000000000000000000000"
    DATA "00000000000000000001111000100011010000010100000001000000010011110100000100100001000111100000000000000000000000000000000000000000"
    DATA "00000000000000000111011100100010001000100010001000111110001000100010001000100010011101110000000000000000000000000000000000000000"
    DATA "00000000000000000011111000001000000010000000100000001000000010000000100000001000001111100000000000000000000000000000000000000000"
    DATA "00000000000000000000111100000010000000100000001000000010000000100100001001000010001111000000000000000000000000000000000000000000"
    DATA "00000000000000000111011100100010001001000010100000110000001010000010010000100010011100110000000000000000000000000000000000000000"
    DATA "00000000000000000111000000100000001000000010000000100000001000000010000100100001011111110000000000000000000000000000000000000000"
    DATA "00000000000000001100001101100110011001100101101001011010010000100100001001000010111001110000000000000000000000000000000000000000"
    DATA "00000000000000000110011100110010001100100011101000101010001011100010011000100110011100100000000000000000000000000000000000000000"
    DATA "00000000000000000011111001000001010000010100000101000001010000010100000101000001001111100000000000000000000000000000000000000000"
    DATA "00000000000000000111111000100001001000010010000100111110001000000010000000100000011100000000000000000000000000000000000000000000"
    DATA "00000000000000000001110000100010010000010100000101000001010000010100000100110110000010010011011000000000000000000000000000000000"
    DATA "00000000000000000111111000100001001000010010000100111110001000100010000100100001011100010000000000000000000000000000000000000000"
    DATA "00000000000000000011110101000011010000010010000000011100000000100100000101100001010111100000000000000000000000000000000000000000"
    DATA "00000000000000000111111101001001010010010000100000001000000010000000100000001000000111000000000000000000000000000000000000000000"
    DATA "00000000000000001110011101000010010000100100001001000010010000100100001001000010001111000000000000000000000000000000000000000000"
    DATA "00000000000000001110011101000010010000100100001001000010010000100100001000100100000110000000000000000000000000000000000000000000"
    DATA "00000000000000001110011101000010010000100100001001000010010110100101101001100110011001100000000000000000000000000000000000000000"
    DATA "00000000000000001110011101000010001001000010010000011000001001000010010001000010111001110000000000000000000000000000000000000000"
    DATA "00000000000000000111011100100010001000100001010000001000000010000000100000001000000111000000000000000000000000000000000000000000"
    DATA "00000000000000000111111101000001010000100000010000001000000100000010000101000001011111110000000000000000000000000000000000000000"
    DATA "00000000000000000011110000110000001100000011000000110000001100000011000000110000001111000000000000000000000000000000000000000000"
    DATA "00000000000000000100000001100000011100000011100000011100000011100000011100000011000000010000000000000000000000000000000000000000"
    DATA "00000000000000000011110000001100000011000000110000001100000011000000110000001100001111000000000000000000000000000000000000000000"
    DATA "00001000000111000011011001100011000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000000000000000000000000000000000000000000000000001111111100000000000000000000000000000000"
    DATA "00011000000110000000110000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000011111000000010001111100100001001000010001111010000000000000000000000000000000000000000"
    DATA "00000000000000000110000000100000001000000011111000100001001000010010000100110001011011100000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000011111001000001010000000100000001000001001111100000000000000000000000000000000000000000"
    DATA "00000000000000000000011000000010000000100001111000100010010000100100001001000110001110110000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000011111001000001011111110100000001000001001111100000000000000000000000000000000000000000"
    DATA "00000000000000000001111000100000001000000010000001111100001000000010000000100000011110000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000011111101000010010000100100001000111110000000100000001000111100000000000000000000000000"
    DATA "00000000000000000110000000100000001000000010110000110010001000100010001000100010011101110000000000000000000000000000000000000000"
    DATA "00000000000000000000000000001100000000000001110000000100000001000000010000000100000111110000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000110000000000000111000000010000000100000001000000010000000100011110000000000000000000000000000000000"
    DATA "00000000000000000110000000100000001001110010001000100100001110000010010000100010011101110000000000000000000000000000000000000000"
    DATA "00000000000000000001110000000100000001000000010000000100000001000000010000000100000111110000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000001110011001011010010110100100001001000010111000110000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000110110000110010001000100010001000100010011101110000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000011111001000001010000010100000101000001001111100000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000110111000110001001000010010000100111110001000000010000001111000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000011101101000110010000100100001000111110000000100000001000001111000000000000000000000000"
    DATA "00000000000000000000000000000000000000000110111000110010001000000010000000100000011110000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000011111001000011001110000000111001100011001111100000000000000000000000000000000000000000"
    DATA "00000000000000000001000000010000000100000111111000010000000100000001000000010001000011100000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000110011000100010001000100010001000100110001110110000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000001110011101000010010000100100001000100100000110000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000001110011101000010010110100101101001100110011001100000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000111011100100010000111000001010000100010011101110000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000111011100100010001000100010001000010100000010000001000001111000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000111111101000001000001100001100000100001011111110000000000000000000000000000000000000000"
    DATA "00000000000000000000111000011000000110000001100001110000000110000001100000011000000011100000000000000000000000000000000000000000"
    DATA "00000000000000000001100000011000000110000001100000000000000110000001100000011000000110000000000000000000000000000000000000000000"
    DATA "00000000000000000111000000011000000110000001100000011100000110000001100000011000011100000000000000000000000000000000000000000000"
    DATA "00000000000000000011101101101110000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000000100000011100001101100110001101100011011000110111111100000000000000000000000000000000"
    DATA "00000000000000000001111000110011011000010110000001100000011000010110001100111110000001100000001100111110000000000000000000000000"
    DATA "00000000000000000110011001100110000000000110011001100110011001100110011001100110001110110000000000000000000000000000000000000000"
    DATA "00000000000001100000110000011000000000000011111001100011011111110110000001100011001111100000000000000000000000000000000000000000"
    DATA "00000000000010000001110000110110000000000011110000000110001111100110011001100110001110110000000000000000000000000000000000000000"
    DATA "00000000000000000110011001100110000000000011110000000110001111100110011001100110001110110000000000000000000000000000000000000000"
    DATA "00000000001100000001100000001100000000000011110000000110001111100110011001100110001110110000000000000000000000000000000000000000"
    DATA "00000000000111000011011000011100000000000011110000000110001111100110011001100110001110110000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000011110001100110011000000110011000111100000001100011110000000000000000000000000000000000"
    DATA "00000000000010000001110000110110000000000011111001100011011111110110000001100011001111100000000000000000000000000000000000000000"
    DATA "00000000000000000110011001100110000000000011111001100011011111110110000001100011001111100000000000000000000000000000000000000000"
    DATA "00000000001100000001100000001100000000000011111001100011011111110110000001100011001111100000000000000000000000000000000000000000"
    DATA "00000000000000000011011000110110000000000001110000001100000011000000110000001100000111100000000000000000000000000000000000000000"
    DATA "00000000000110000011110001100110000000000011100000011000000110000001100000011000001111000000000000000000000000000000000000000000"
    DATA "00000000011000000011000000011000000000000011100000011000000110000001100000011000001111000000000000000000000000000000000000000000"
    DATA "00000000011000110110001100001000000111000011011001100011011000110111111101100011011000110000000000000000000000000000000000000000"
    DATA "00011100001101100001110000000000000111000011011001100011011000110111111101100011011000110000000000000000000000000000000000000000"
    DATA "00001100000110000011000000000000011111110011001100110000001111100011000000110011011111110000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000110111000111011000110110111111011011000110111000111011100000000000000000000000000000000"
    DATA "00000000000000000001111100110110011001100110011001111111011001100110011001100110011001110000000000000000000000000000000000000000"
    DATA "00000000000010000001110000110110000000000011111001100011011000110110001101100011001111100000000000000000000000000000000000000000"
    DATA "00000000000000000110001101100011000000000011111001100011011000110110001101100011001111100000000000000000000000000000000000000000"
    DATA "00000000001100000001100000001100000000000011111001100011011000110110001101100011001111100000000000000000000000000000000000000000"
    DATA "00000000000110000011110001100110000000000110011001100110011001100110011001100110001110110000000000000000000000000000000000000000"
    DATA "00000000001100000001100000001100000000000110011001100110011001100110011001100110001110110000000000000000000000000000000000000000"
    DATA "00000000000000000110001101100011000000000110001101100011011000110110001100111111000000110000011000111100000000000000000000000000"
    DATA "00000000011000110110001100011100001101100110001101100011011000110110001100110110000111000000000000000000000000000000000000000000"
    DATA "00000000011000110110001100000000011000110110001101100011011000110110001101100011001111100000000000000000000000000000000000000000"
    DATA "00000000000110000001100001111110110000111100000011000000110000110111111000011000000110000000000000000000000000000000000000000000"
    DATA "00000000000111000011011000110000001100000111100000110000001100000011000001110011011111100000000000000000000000000000000000000000"
    DATA "00000000000000001100001101100110001111000001100011111111000110001111111100011000000110000000000000000000000000000000000000000000"
    DATA "00000000111111000110011001100110011111000110001001100110011011110110011001100110111100110000000000000000000000000000000000000000"
    DATA "00000000000011100001101100011000000110000001100001111110000110000001100000011000000110001101100001110000000000000000000000000000"
    DATA "00000000000011000001100000110000000000000011110000000110001111100110011001100110001110110000000000000000000000000000000000000000"
    DATA "00000000000011000001100000110000000000000011100000011000000110000001100000011000001111000000000000000000000000000000000000000000"
    DATA "00000000000011000001100000110000000000000011111001100011011000110110001101100011001111100000000000000000000000000000000000000000"
    DATA "00000000000011000001100000110000000000000110011001100110011001100110011001100110001110110000000000000000000000000000000000000000"
    DATA "00000000000000000011101101101110000000000110111000110011001100110011101100110011001100110011001100000000000000000000000000000000"
    DATA "00111011011011100000000001100011011100110111101101111111011011110110011101100011011000110000000000000000000000000000000000000000"
    DATA "00000000001111000110110001101100001111100000000001111110000000000000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000001110000110110001101100001110000000000001111100000000000000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000001100000011000000000000001100000011000001100110011001100011110000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000000000001111111011000000110000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000000000001111111000000110000001100000000000000000000000000000000000000000000000000000000"
    DATA "00000000011000001110000001100011011001100110110000011000001100000110111011000011000001100000110000011111000000000000000000000000"
    DATA "00000000011000001110000001100011011001100110110000011000001100000110011111001111000111110000001100000011000000000000000000000000"
    DATA "00000000000000000001100000011000000000000001100000011000001111000011110000111100000110000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000110110011011001101100001101100001101100000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000011011000011011000011011001101100110110000000000000000000000000000000000000000000000000000000000"
    DATA "10000010000100001000001000010000100000100001000010000010000100001000001000010000100000100001000010000010000100001000001000010000"
    DATA "11000011000110001100001100011000110000110001100011000011000110001100001100011000110000110001100011000011000110001100001100011000"
    DATA "11011000100000111101101000010011110110001000001111011010000100111101100010000011110110100001001111011000100000111101101000010011"
    DATA "00011000000110000001100000011000000110000001100000011000000110000001100000011000000110000001100000011000000110000001100000011000"
    DATA "00011000000110000001100000011000000110000001100000011000111110000001100000011000000110000001100000011000000110000001100000011000"
    DATA "00011000000110000001100000011000000110001111100000011000111110000001100000011000000110000001100000011000000110000001100000011000"
    DATA "00110110001101100011011000110110001101100011011000110110111101100011011000110110001101100011011000110110001101100011011000110110"
    DATA "00000000000000000000000000000000000000000000000000000000111111100011011000110110001101100011011000110110001101100011011000110110"
    DATA "00000000000000000000000000000000000000001111100000011000111110000001100000011000000110000001100000011000000110000001100000011000"
    DATA "00110110001101100011011000110110001101101111011000000110111101100011011000110110001101100011011000110110001101100011011000110110"
    DATA "00110110001101100011011000110110001101100011011000110110001101100011011000110110001101100011011000110110001101100011011000110110"
    DATA "00000000000000000000000000000000000000001111111000000110111101100011011000110110001101100011011000110110001101100011011000110110"
    DATA "00110110001101100011011000110110001101101111011000000110111111100000000000000000000000000000000000000000000000000000000000000000"
    DATA "00110110001101100011011000110110001101100011011000110110111111100000000000000000000000000000000000000000000000000000000000000000"
    DATA "00011000000110000001100000011000000110001111100000011000111110000000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000000000000000000111110000001100000011000000110000001100000011000000110000001100000011000"
    DATA "00011000000110000001100000011000000110000001100000011000000111110000000000000000000000000000000000000000000000000000000000000000"
    DATA "00011000000110000001100000011000000110000001100000011000111111110000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000000000000000000111111110001100000011000000110000001100000011000000110000001100000011000"
    DATA "00011000000110000001100000011000000110000001100000011000000111110001100000011000000110000001100000011000000110000001100000011000"
    DATA "00000000000000000000000000000000000000000000000000000000111111110000000000000000000000000000000000000000000000000000000000000000"
    DATA "00011000000110000001100000011000000110000001100000011000111111110001100000011000000110000001100000011000000110000001100000011000"
    DATA "00011000000110000001100000011000000110000001111100011000000111110001100000011000000110000001100000011000000110000001100000011000"
    DATA "00110110001101100011011000110110001101100011011000110110001101110011011000110110001101100011011000110110001101100011011000110110"
    DATA "00110110001101100011011000110110001101100011011100110000001111110000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000011111100110000001101110011011000110110001101100011011000110110001101100011011000110110"
    DATA "00110110001101100011011000110110001101101111011100000000111111110000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000001111111100000000111101110011011000110110001101100011011000110110001101100011011000110110"
    DATA "00110110001101100011011000110110001101100011011100110000001101110011011000110110001101100011011000110110001101100011011000110110"
    DATA "00000000000000000000000000000000000000001111111100000000111111110000000000000000000000000000000000000000000000000000000000000000"
    DATA "00110110001101100011011000110110001101101111011100000000111101110011011000110110001101100011011000110110001101100011011000110110"
    DATA "00011000000110000001100000011000000110001111111100000000111111110000000000000000000000000000000000000000000000000000000000000000"
    DATA "00110110001101100011011000110110001101100011011000110110111111110000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000001111111100000000111111110001100000011000000110000001100000011000000110000001100000011000"
    DATA "00000000000000000000000000000000000000000000000000000000111111110011011000110110001101100011011000110110001101100011011000110110"
    DATA "00110110001101100011011000110110001101100011011000110110001111110000000000000000000000000000000000000000000000000000000000000000"
    DATA "00011000000110000001100000011000000110000001111100011000000111110000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000001111100011000000111110001100000011000000110000001100000011000000110000001100000011000"
    DATA "00000000000000000000000000000000000000000000000000000000001111110011011000110110001101100011011000110110001101100011011000110110"
    DATA "00110110001101100011011000110110001101100011011000110110111111110011011000110110001101100011011000110110001101100011011000110110"
    DATA "00011000000110000001100000011000000110001111111100011000111111110001100000011000000110000001100000011000000110000001100000011000"
    DATA "00011000000110000001100000011000000110000001100000011000111110000000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000000000000000000000111110001100000011000000110000001100000011000000110000001100000011000"
    DATA "11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111"
    DATA "00000000000000000000000000000000000000000000000000000000111111111111111111111111111111111111111111111111111111111111111111111111"
    DATA "11110000111100001111000011110000111100001111000011110000111100001111000011110000111100001111000011110000111100001111000011110000"
    DATA "00001111000011110000111100001111000011110000111100001111000011110000111100001111000011110000111100001111000011110000111100001111"
    DATA "11111111111111111111111111111111111111111111111111111111000000000000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000011101101101110011011000110110001101110001110110000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000001111100110001101111110011000110110001101111110011000000110000000100000000000000000000000000000"
    DATA "00000000000000000111111101100011011000110110000001100000011000000110000001100000011000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000011111110011011000110110001101100011011000110110001101100000000000000000000000000000000000000000"
    DATA "00000000000000000111111101100011001100000001100000001100000110000011000001100011011111110000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000011111001101100011011000110110001101100001110000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000001100110011001100110011001100110011111000110000001100000110000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000001110110110111000001100000011000000110000001100000011000000000000000000000000000000000000000000"
    DATA "00000000000000000111111000011000001111000110011001100110011001100011110000011000011111100000000000000000000000000000000000000000"
    DATA "00000000000000000001110000110110011000110110001101111111011000110110001100110110000111000000000000000000000000000000000000000000"
    DATA "00000000000000000001110000110110011000110110001101100011001101100001110000110110001101100111011100000000000000000000000000000000"
    DATA "00000000000000000001111000110000000110000000110000111110011001100110011001100110001111000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000111111011011011110110110111111000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000001100000110011111101101101111011011111100110111111001100000110000000000000000000000000000000000000000000000"
    DATA "00000000000000000001110000110000011000000110000001111100011000000110000000110000000111000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000001111100110001101100011011000110110001101100011011000110110001100000000000000000000000000000000"
    DATA "00000000000000000000000000000000011111110000000001111111011111110000000001111111000000000000000000000000000000000000000000000000"
    DATA "00000000000000000001100000011000000110001111111100011000000110000001100000000000111111110000000000000000000000000000000000000000"
    DATA "00000000000000000011000000011000000011000000011000001100000110000011000000000000111111110000000000000000000000000000000000000000"
    DATA "00000000000000000000110000011000001100000110000000110000000110000000110000000000111111110000000000000000000000000000000000000000"
    DATA "00000000000000000000111000011011000110110001100000011000000110000001100000011000000110000001100000011000000110000000000000000000"
    DATA "00011000000110000001100000011000000110000001100000011000000110001101100011011000011100000000000000000000000000000000000000000000"
    DATA "00000000000000000001100000011000000000000000000011111111000000000000000000011000000110000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000001110110110111000000000001110110110111000000000000000000000000000000000000000000000000000000000"
    DATA "00000000001110000110110001101100001110000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000000000000011000000110000000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000000000000000000001100000000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000011110000110000001100000011000000110000001100111011000110110000111100000111000000000000000000000000000000000000000000"
    DATA "00000000110110000110110001101100011011000110110001101100000000000000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000011100001101100000110000011000001100100011111000000000000000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000001111000011110000111100001111000011110000111100000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000"

    Font20:
    DATA "00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000111111010000001101001011010010110000001100110011010010110011001100000010111111000000000000000000000000000000000"
    DATA "00000000000000000111111011111111110111011010101011111111111001111101101111100111011111100000000000000000000000000000000000000000"
    DATA "00000000000000000000000001101100111111101111111011111110111111100111110000111000000100000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000010000001110000111110011111110011111000011100000010000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000001100000111100001111001110011111100111111001110001100000011000001111000000000000000000000000000000000000000000"
    DATA "00000000000000000001100000111100011111101111111111111111011111100001100000011000001111000000000000000000000000000000000000000000"
    DATA "00000000000000000000000011000110011011000010100011111110001010000110110011000110000000000000000000000000000000000000000000000000"
    DATA "00000000000010000001100000110000011000001111110000011000001100000110000011111110000011000001100000110000001000000011000000100000"
    DATA "00000000000000000000000000000000001111000110011001000010010000100110011000111100000000000000000000000000000000000000000000000000"
    DATA "00000000110001100100010001101100011111001101011010010010111111100111110000111000011111000000000000000000000000000000000000000000"
    DATA "00000000000000000001111000001110000110100011001001111000110011001100110011001100011110000000000000000000000000000000000000000000"
    DATA "00000000000000000011110001100110011001100110011000111100000110000111111000011000000110000000000000000000000000000000000000000000"
    DATA "00000000000000000011111100110011001111110011000000110000001100000111000011110000111000000000000000000000000000000000000000000000"
    DATA "00000000000000000111111101100011011111110110001101100011011000110110011111100111111001101100000000000000000000000000000000000000"
    DATA "00000000000000000001100010011001010110100011110011100111001111000101101010011001000110000000000000000000000000000000000000000000"
    DATA "00000000000000000000000001000000011000000111100001111110011110000110000001000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000010000001100001111001111110000111100000011000000010000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000011000001111000111111000011000000110000111111000111100000110000000000000000000000000000000000000000000"
    DATA "00000000000000000101001011111110110101101101011000000110000011000001100000110000011000000110011000111100000000000000000000000000"
    DATA "00000000000000000111110001100110011001100111110001100000011011100111100001101100011001100000000000000000000000000000000000000000"
    DATA "00000000000000100000011000001110000111100011011001100110000011100001111000110110011001100000000000000000000000000000000000000000"
    DATA "00000000000000000000000011111110100000101011101010101010101110101000001011111110000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000100000011100001111100000100000001000000010000011111000011100000010000011111000000000000000000000000000000000"
    DATA "00000000000000000001100000111100011111100001100000011000000110000001100000011000000110000000000000000000000000000000000000000000"
    DATA "00000000000000000001100000011000000110000001100000011000000110000111111000111100000110000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000110000000110011111110000011000001100000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000001100000110000011111110011000000011000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000000000000110000001100000011111000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000101000011011001111111001101100001010000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000010000001110000011100001111100011111001111111011111110000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000011111110111111100111110001111100001110000011100000010000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000110000001100000011000001100000011000000110000000000000110000001100000000000000000000000000000000000000000000"
    DATA "00000000001000100011001101100110100010000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000110110001101100111111100110110001101100011011001111111001101100011011000000000000000000000000000000000000000000"
    DATA "00000000000000000000011000000100000111100011000000100000000110000000100001001100111110000010000001100000000000000000000000000000"
    DATA "00000000000000000000000000000000110000101100011000001100000110000011000001100110110001100000000000000000000000000000000000000000"
    DATA "00000000000000000011100001101100011011000011100001110110110111001100110011001100011101100000000000000000000000000000000000000000"
    DATA "00000000000011000000110000011000001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000111000011000001100000110000001100000011000000110000000110000000110000000000000000000000000000000000000000000"
    DATA "00000000000000000001100000001100000001100000011000000110000001100000110000011000011100000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000011001100011110001111110001111000110011000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000110000001100001111110000110000001100000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000000000000000000000000000001100000011000000110000011000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000000000001111110000000000000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000000000000000000000000000000000000011000000110000000000000000000000000000000000000000000"
    DATA "00000000000000000000001000000110000011000001100000110000011000001100000010000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000011100001001100100011001001010100101001010010011001000011100000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000001100001101000000110000001000000110000001000000110000001100000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000111100011001101100011000001100001110000110000011000110111111000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000111100010001100000011001111100000010000000010010001100011110000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000010000011100011111001100100110001000111111000001000000110000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000111110001000000100000001111000000011000000010010001100011110000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000001100001100000110000001011100110001101000011011001100011110000000000000000000000000000000000000000000"
    DATA "00000000000000000000000001111110100001100000010000001100001111100001100000110000011000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000011100001101100010010000011000011001001100010011001100011110000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000111100011000101100011001111100000011000001100000110000011000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000001100000011000000000000000000000000000001100000011000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000001100000011000000000000000000000000000001100000011000001100000000000000000000000000000000000000000000"
    DATA "00000000000000000000011000001100000110000011000001100000001100000001100000001100000001100000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000011111000000000000000000111110000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000110000000110000000110000000110000000110000011000001100000110000011000000000000000000000000000000000000000000000"
    DATA "00000000000000000011111001000011000001100000110000011000000100000000000000110000001100000000000000000000000000000000000000000000"
    DATA "00000000000000000111110011000110110001101101111011011110110111101101110011000000011111000000000000000000000000000000000000000000"
    DATA "00000000000000000000000100000010000001100000111000010010001100101111111111000010100000110000000000000000000000000000000000000000"
    DATA "00000000000000000011111001100001000010010000100100111110001001000100011011001110011111000000000000000000000000000000000000000000"
    DATA "00000000000000000000011100011001001000100110000011000000110000001100001011101100011100000000000000000000000000000000000000000000"
    DATA "00000000000000000111110011100110000100110010001100100011010000110100011010001100111110000000000000000000000000000000000000000000"
    DATA "00000000000000000000111100111001011100000111000000011100001100000110000001100110011111000000000000000000000000000000000000000000"
    DATA "00000000000000000001111101110011000000100000001000011111000001000000100000010000011000000000000000000000000000000000000000000000"
    DATA "00000000000000000000011100011001001100000110001001100110011010100011001000000100000011110001000000100000000000000000000000000000"
    DATA "00000000000000000111000110011001000100110011001000110110111111110110011011000110110011000000000000000000000000000000000000000000"
    DATA "00000000000000000001110000100100010001000100010000001100000010000001100000110000001100000000000000000000000000000000000000000000"
    DATA "00000000000000000000110000011010001100100011001001100010011001000110010000001000000111000110000011000000100000000000000000000000"
    DATA "00000000000000000011100011101001100010100000110000011000011100000011110001100110010000010000000000000000000000000000000000000000"
    DATA "00000000000000000000011000001010000010100001000000010000001000000010000011110001000111110000000000000000000000000000000000000000"
    DATA "00000000000000000001000100010011001101110111111101101001011010111100001010000110100001100000000000000000000000000000000000000000"
    DATA "00000000000000000011000011110011100101110010010100101010011100100110011011000110110000110000000000000000000000000000000000000000"
    DATA "00000000000000000000111000111111011000110100001111000011100001101000011010001100011100000000000000000000000000000000000000000000"
    DATA "00000000000000000111110011001010000100110001001100110011011011100110000011000000110000000000000000000000000000000000000000000000"
    DATA "00000000000000000001110000110110011000100100001001100100000010000001000011100010001111000000000000000000000000000000000000000000"
    DATA "00000000000000000111111011010011000100010010001001111100011100000101100010001100100001100000000000000000000000000000000000000000"
    DATA "00000000000000000001111100110010001000000011000000010000000010000000110001001100111110000000000000000000000000000000000000000000"
    DATA "00000000000000000111111011100110000010000000100000010000000100000010000000100000001100000000000000000000000000000000000000000000"
    DATA "00000000000000000111000111010001000100110011001000100010011001100110011001101010001100110000000000000000000000000000000000000000"
    DATA "00000000000000000011100101101001000110010001001100010010001100100010110000111000000100000000000000000000000000000000000000000000"
    DATA "00000000000000000111000111010001001000010010000101101001010010111101101011101110010011000000000000000000000000000000000000000000"
    DATA "00000000000000000010000111110001000100100001110000001000000110000010110001001100100001100000000000000000000000000000000000000000"
    DATA "00000000000000000111000011010001000100110011001100100111011001100100101001110010011001000000010100001110000010000000000000000000"
    DATA "00000000000000000011110001110010110001000000100000010000001111100100011000001010000101000010010000011000000000000000000000000000"
    DATA "00000000000000000001111000010000001100000011000000100000011000000110000001000000111110000000000000000000000000000000000000000000"
    DATA "00000000000000001000000011000000011000000011000000011000000011000000011000000010000000000000000000000000000000000000000000000000"
    DATA "00000000000000000001111000000010000001100000011000000100000011000000110000001000011110000000000000000000000000000000000000000000"
    DATA "00010000001110000110110011000110000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000011111111000000000000000000000000"
    DATA "00110000001100000001100000000100000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000001100000111100011001001100010011001101011101100000000000000000000000000000000000000000"
    DATA "00000000000000000001100000101000001100000110000001111000110011111000110011011000011100000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000001110000100010011000000100000001100011001111000000000000000000000000000000000000000000"
    DATA "00000000000000000000001100000010000001100011010001101100110010001000100011011001011011100000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000001110000100100010010000101000101000110001111000000000000000000000000000000000000000000"
    DATA "00000000000000000000110000010100000101000001100000111000001100001110000001011111010011000100100001011000001100000000000000000000"
    DATA "00000000000000000000000000000000000000000011100001101100110001001100110001101001000011100011100001010000011000000000000000000000"
    DATA "00000000000000000011000000110000011000000110000011001110110100101010010011000101100001100000000000000000000000000000000000000000"
    DATA "00000000000000000000000000001100000000000001100000010000001100000110000101100010001111000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000110000000000000110000011100001110001111100000011111001110000111000010100000011000000000000000000000"
    DATA "00000000000000000000110000010100000110000011000001100110011010101111110001111001001011100000000000000000000000000000000000000000"
    DATA "00000000000000000000011000001010000101000001010000101000001010000011000001110011100111000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000001001010110110111111101101101010010011100100100000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000100011001001100010101000111010001100101010001100000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000001110000100110010001111100010011001000011100000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000100000010000001100000110110010111101010011000110100011111110100000011000000110000000000000000000000"
    DATA "00000000000000000000000000000000000000000011100001101100110011001101100001010011001011000010100001010000011000000000000000000000"
    DATA "00000000000000000000000000000000000000000011110001001100110010000000100000001001000001100000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000001000000011000001011000100110011100101001111100000000000000000000000000000000000000000"
    DATA "00000000000000000000010000001000011111100001100000110000001000000110001101101110001110000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000010001001100110010011001101110011110101011001100000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000011001001100110010001000100111101111000001100000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000010001000100001011010010100100111011011011011100000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000011001001010100100110000010100001001101100001100000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000010001001100110010011101101010001100100000010110001110000010000001100000000000000000000"
    DATA "00000000000000000000000000000000000000000100000001111100000001100000100000110001000010100000110000010100000110000000000000000000"
    DATA "00000000000000000000111000011000000110000001100001110000000110000001100000011000000011100000000000000000000000000000000000000000"
    DATA "00000000000000000001100000011000000110000001100000000000000110000001100000011000000110000000000000000000000000000000000000000000"
    DATA "00000000000000000111000000011000000110000001100000001110000110000001100000011000011100000000000000000000000000000000000000000000"
    DATA "00000000000000000111011011011100000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000100000011100001101100110001101100011011111110000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000011100011001001000100110000011000000110000001100001011101100011100000001000000001000001110000000000000000000"
    DATA "00000000000000000000100100010010000000000010001001100110010011001101110011110101011001100000000000000000000000000000000000000000"
    DATA "00000000000001100000110000010000000000000001110000100100010010000101000101000110001111000000000000000000000000000000000000000000"
    DATA "00000000000010000001010000100010000000000001100000111100011001001100010011001101011101100000000000000000000000000000000000000000"
    DATA "00000000000000000001001000100100000000000001100000111100011001001100010011001101011101100000000000000000000000000000000000000000"
    DATA "00000000011000000011000000001000000000000001100000111100011001001100010011001101011101100000000000000000000000000000000000000000"
    DATA "00000000000111000011011000011100000000000001100000111100011001001100010011001101011101100000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000001110000100010010000000110001100111100000010000000100000110000000000000000000000000000"
    DATA "00000000000010000001010000100010000000000001110000100100010010000101000101000110001111000000000000000000000000000000000000000000"
    DATA "00000000000000000001001000100100000000000001110000100100010010000101000101000110001111000000000000000000000000000000000000000000"
    DATA "00000000001100000001100000000100000000000001110000100100010010000101000101000110001111000000000000000000000000000000000000000000"
    DATA "00000000000000000000100100010010000000000001100000010000001100000110000101100010001111000000000000000000000000000000000000000000"
    DATA "00000000000001000000101000010001000000000001100000010000001100000110000101100010001111000000000000000000000000000000000000000000"
    DATA "00000000011000000011000000001000000000000001100000010000001100000110000101100010001111000000000000000000000000000000000000000000"
    DATA "00000000000010010001001000000000000000100000011000001110000100101111111101000010100000110000000000000000000000000000000000000000"
    DATA "00001100000100100000110000000000000000100000011000001110000100101111111101000010100000110000000000000000000000000000000000000000"
    DATA "00000000000010010001001000000000000011110011100100110000000111000011000001100000001111000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000011011100011101100011011011111101101100011011100011101110000000000000000000000000000000000000000"
    DATA "00000000000000000000001100000110000011000001110000100111011001001111110011000110100000110000000000000000000000000000000000000000"
    DATA "00000000000001000000101000010001000000000001110000100110010001111100010011001000011100000000000000000000000000000000000000000000"
    DATA "00000000000000000000100100010010000000000001110000100110010001111100010011001000011100000000000000000000000000000000000000000000"
    DATA "00000000001100000001100000000100000000000001110000100110010001111100010011001000011100000000000000000000000000000000000000000000"
    DATA "00000000000001000000101000010001000000000010001001100110010011001101110011110101011001100000000000000000000000000000000000000000"
    DATA "00000000001100000001100000000100000000000010001001100110010011001101110011110101011001100000000000000000000000000000000000000000"
    DATA "00000000000000000000100100010010000000000010001001100110010011101101010001100100000010110001110000010000001100000000000000000000"
    DATA "00001001000100100000000000001110001111110110001101000011110001101000011010001100011100000000000000000000000000000000000000000000"
    DATA "00001001000100100000000001110001110100010001001100110010011001100110011001101010001100110000000000000000000000000000000000000000"
    DATA "00000000000000000000110000001000000111000010001001100000010000000110001100111100000100000011000000000000000000000000000000000000"
    DATA "00000000001110000110110001100100011000001111000001100000011000000110000011100110111111000000000000000000000000000000000000000000"
    DATA "00000000000000001100001101100110001111000001100011111111000110001111111100011000000110000000000000000000000000000000000000000000"
    DATA "00000000001100000110111001100110011001100110011011110110011001100110011001100110011011110110000011000000000000000000000000000000"
    DATA "00000000001100110110011001100110011001100110011011111111011001100110011001100110011001100110011011001100000000000000000000000000"
    DATA "00000000000001100000110000010000000000000001100000111100011001001100010011001101011101100000000000000000000000000000000000000000"
    DATA "00000000000001100000110000010000000000000001100000010000001100000110000101100010001111000000000000000000000000000000000000000000"
    DATA "00000000000001100000110000010000000000000001110000100110010001111100010011001000011100000000000000000000000000000000000000000000"
    DATA "00000000000001100000110000010000000000000010001001100110010011001101110011110101011001100000000000000000000000000000000000000000"
    DATA "00000000000000000011001001001100000000000100011001001100010101000111010001100101010001100000000000000000000000000000000000000000"
    DATA "00110001010011100000000000110000111100111001011100100101001010100111001001100110110001110000000000000000000000000000000000000000"
    DATA "00000000001111000110110001101100001111100000000001111110000000000000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000001110000110110001101100001110000000000001111100000000000000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000011000000110000000000000011000000110000011000001100011011000110011111000000000000000000000000000000000000000000"
    DATA "00000000111111110000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000000000001111100000011000000110000000000000000000000000000000000000000000000000000000000"
    DATA "00000000110000001100000011000110110011001101100000110000011000001101110010000110000011000001100000111110000000000000000000000000"
    DATA "00000000110000001100000011000110110011001101100000110000011001101100111010011110001111100000011000000110000000000000000000000000"
    DATA "00000000000000000000110000001100000000000001100000011000000110000011000000110000001100000000000000000000000000000000000000000000"
    DATA "00000000110011001100110011001100011001100000000000000000000000000000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000001100110011001100110011011001100000000000000000000000000000000000000000000000000000000000000000000000000000000000000000"
    DATA "00010001010001000001000101000100000100010100010000010001010001000001000101000100000100010100010000010001010001000001000101000100"
    DATA "01010101101010100101010110101010010101011010101001010101101010100101010110101010010101011010101001010101101010100101010110101010"
    DATA "11011101011101111101110101110111110111010111011111011101011101111101110101110111110111010111011111011101011101111101110101110111"
    DATA "00011000000110000001100000011000000110000001100000011000000110000001100000011000000110000001100000011000000110000001100000011000"
    DATA "00011000000110000001100000011000000110000001100000111000111100000011100000011000000110000001100000011000000110000001100000011000"
    DATA "00011000000110000001100000011000001110001111000000111000111100000011100000011000000110000001100000011000000110000001100000011000"
    DATA "00110110001101100011011000110110001101100011011001110110111001100111011000110110001101100011011000110110001101100011011000110110"
    DATA "00000000000000000000000000000000000000000000000000000000111011000111111000110110001101100011011000110110001101100011011000110110"
    DATA "00000000000000000000000000000000000000001111000000111000111100000011100000011000000110000001100000011000000110000001100000011000"
    DATA "00110110001101100011011000110110011101101110011000000110111001100111011000110110001101100011011000110110001101100011011000110110"
    DATA "00110110001101100011011000110110001101100011011000110110001101100011011000110110001101100011011000110110001101100011011000110110"
    DATA "00000000000000000000000000000000000000001111110000001110111001100111011000110110001101100011011000110110001101100011011000110110"
    DATA "00110110001101100011011000110110011101101110011000001110111111000000000000000000000000000000000000000000000000000000000000000000"
    DATA "00110110001101100011011000110110001101100011011001111110110011000000000000000000000000000000000000000000000000000000000000000000"
    DATA "00011000000110000001100000011000001110001111000000111000111100000000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000000000000000000111100000001100000011000000110000001100000011000000110000001100000011000"
    DATA "00011000000110000001100000011000000110000001100000011000000011110000000000000000000000000000000000000000000000000000000000000000"
    DATA "00011000000110000001100000011000000110000001100000111100111001110000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000000000000000000111001110011110000011000000110000001100000011000000110000001100000011000"
    DATA "00011000000110000001100000011000000110000001100000001100000001110000110000011000000110000001100000011000000110000001100000011000"
    DATA "00000000000000000000000000000000000000000000000000000000111111110000000000000000000000000000000000000000000000000000000000000000"
    DATA "00011000000110000001100000011000000110000001100000111100111001110011110000011000000110000001100000011000000110000001100000011000"
    DATA "00011000000110000001100000011000000111000000111100000110000011110001110000011000000110000001100000011000000110000001100000011000"
    DATA "00110110001101100011011000110110001101100011011000110111001100110011011100110110001101100011011000110110001101100011011000110110"
    DATA "00110110001101100011011000110110001101110011001100111000000111110000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000001111100111000001100110011011100110110001101100011011000110110001101100011011000110110"
    DATA "00110110001101100011011000110110011101111110001100000000111111110000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000001111111100000000111000110111011100110110001101100011011000110110001101100011011000110110"
    DATA "00110110001101100011011000110110001101110011001100110000001100110011011100110110001101100011011000110110001101100011011000110110"
    DATA "00000000000000000000000000000000000000001111111100000000111111110000000000000000000000000000000000000000000000000000000000000000"
    DATA "00110110001101100011011000110110011101111110001100000000111000110111011100110110001101100011011000110110001101100011011000110110"
    DATA "00011000000110000001100000011000001111001110011100000000111111110000000000000000000000000000000000000000000000000000000000000000"
    DATA "00110110001101100011011000110110001101100011011001111111111000110000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000001111111100000000111001110011110000011000000110000001100000011000000110000001100000011000"
    DATA "00000000000000000000000000000000000000000000000000000000111000110111011100111110001101100011011000110110001101100011011000110110"
    DATA "00110110001101100011011000110110001101100011011000111111000110010000000000000000000000000000000000000000000000000000000000000000"
    DATA "00011000000110000001100000011000000111000000111100011100000011110000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000000111100011100000011110001110000011000000110000001100000011000000110000001100000011000"
    DATA "00000000000000000000000000000000000000000000000000000000000110010011111100110110001101100011011000110110001101100011011000110110"
    DATA "00110110001101100011011000110110001101100011011001111111110010010111111100110110001101100011011000110110001101100011011000110110"
    DATA "00011000000110000001100000011000001111001110011100111100111001110011110000011000000110000001100000011000000110000001100000011000"
    DATA "00011000000110000001100000011000000110000001100000111000111100000000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000000000000000000000011110001110000011000000110000001100000011000000110000001100000011000"
    DATA "11111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111"
    DATA "00000000000000000000000000000000000000000000000000000000000000001111111111111111111111111111111111111111111111111111111111111111"
    DATA "11110000111100001111000011110000111100001111000011110000111100001111000011110000111100001111000011110000111100001111000011110000"
    DATA "00001111000011110000111100001111000011110000111100001111000011110000111100001111000011110000111100001111000011110000111100001111"
    DATA "11111111111111111111111111111111111111111111111111111111111111110000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000111011011011100110110001101100011011100011101100000000000000000000000000000000000000000"
    DATA "00000000000000000111111011001010110010101100101001111010000010100000101000001010000111100000000000000000000000000000000000000000"
    DATA "00000000000000001111111011000110110001101100000011000000110000001100000011000000110000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000111111100110110001101100011011000110110001101100011011000000000000000000000000000000000000000000"
    DATA "00000000000000001111111011000110011000000011000000011000001100000110000011000110111111100000000000000000000000000000000000000000"
    DATA "00000000111100001001000000100000100100001111011000001100000110000011001001100110110011100001111000000010000000000000000000000000"
    DATA "00000000000000000000000000000000011001100110011001100110011001100111110001100000011000001100000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000011101101101110000011000000110000001100000011000000110000000000000000000000000000000000000000000"
    DATA "00000000000000000111111000011000001111000110011001100110011001100011110000011000011111100000000000000000000000000000000000000000"
    DATA "00000000000000000011100001101100110001101100011011111110110001101100011001101100001110000000000000000000000000000000000000000000"
    DATA "00000000000000000011100001101100110001101100011011000110011011000110110001101100111011100000000000000000000000000000000000000000"
    DATA "00000000011111001100011011000000011000000111110011000110110001100111110000001100000001101100011001111100000000000000000000000000"
    DATA "00000000000000000000000000000000000000000111111011011011110110110111111000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000001100000110011111101101101111011011111100110111111001100000110000000000000000000000000000000000000000000000"
    DATA "00000000000000000001110000110000011000000110000001111100011000000110000000110000000111000000000000000000000000000000000000000000"
    DATA "00000000000000000000000001111100110001101100011011000110110001101100011011000110110001100000000000000000000000000000000000000000"
    DATA "00000000000000000000000011111110000000000000000011111110000000000000000011111110000000000000000000000000000000000000000000000000"
    DATA "00000000000000000001100000011000000110001111111100011000000110000001100000000000111111110000000000000000000000000000000000000000"
    DATA "00000000000000000011000000011000000011000000011000001100000110000011000000000000011111100000000000000000000000000000000000000000"
    DATA "00000000000000000000110000011000001100000110000000110000000110000000110000000000011111100000000000000000000000000000000000000000"
    DATA "00000000000000000000111000011011000110110001100000011000000110000001100000011000000110000001100000011000000110000001100000011000"
    DATA "00011000000110000001100000011000000110000001100000011000000110001101100011011000011100000000000000000000000000000000000000000000"
    DATA "00000000000000000001100000011000000000000000000011111111000000000000000000011000000110000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000011101101101110000000000011101101101110000000000000000000000000000000000000000000000000000000000"
    DATA "00000000001110000110110001101100001110000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000000000000011000000110000000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000000000000000000000110000000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000011110000110000001100000011000000110000001100111011000110110000111100000111000000000000000000000000000000000000000000"
    DATA "00000000110110000110110001101100011011000110110001101100000000000000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000011100001101100000110000011000001100100011111000000000000000000000000000000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000011111000111110001111100011111000111110001111100000000000000000000000000000000000000000000000000"
    DATA "00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000"
END SUB


